//
// Skirmish Base Script.
//
// contains the rules for starting and ending a game.
// as well as warning messages.
//
// /////////////////////////////////////////////////////////////////

var lastHitTime = 0;
var n = 0;
var scavengerPlayer = (scavengers) ? Math.max(7,maxPlayers) : -1;

var stats = {

	scavs: 
	[
		{ name: "Trike",	 body: "B4body-sml-trike01", propulsion: "BaBaProp", weapons: [ "bTrikeMG"],   type:[DROID_WEAPON]   }, // 
		{ name: "Buggy",     body: "B3body-sml-buggy01", propulsion: "BaBaProp", weapons: [ "BuggyMG"],    type:[DROID_WEAPON]   }, // 
		{ name: "Jeep",      body: "B2JeepBody",         propulsion: "BaBaProp", weapons: [ "BJeepMG"],    type:[DROID_WEAPON]  }, // 
		{ name: "Cannonbus", body: "BusBody",            propulsion: "BaBaProp", weapons: [ "BusCannon"],  type:[DROID_WEAPON]   }, // 
		{ name: "Firebus",   body: "FireBody",           propulsion: "BaBaProp", weapons: [ "BabaFlame"],  type:[DROID_WEAPON]  }, // 
		{ name: "Bloke",     body: "B1BaBaPerson01",     propulsion: "BaBaLegs", weapons: [ "BaBaCannon"], type:[DROID_PERSON]  }, // 
	
	],

};
var scavTemplate = stats.scavs;
var spawnPosition = [[19, 39],
					 [49, 39],
					 [82, 39],
					 [19, 110],
					 [49, 110],
					 [82, 110]
];
var attackPosition = [[82, 140],
					  [49, 140],
					  [19, 140],
					  [82, 10],
	        		  [49, 10],
					  [19, 10]	
];
				 

					  
					  
					  
					  
	//var droidType = DROID_WEAPON;
		

function eventGameInit()
{
	hackNetOff();
	for (var playnum = 0; playnum < maxPlayers; playnum++)
	{
		enableStructure("A0CommandCentre", playnum);		// make structures available to build
		enableStructure("A0LightFactory", playnum);
		enableStructure("A0ResourceExtractor", playnum);
		enableStructure("A0PowerGenerator", playnum);
		enableStructure("A0ResearchFacility", playnum);

		// We need to enable these in order for scripts to be able to generate their templates.
		makeComponentAvailable("CyborgLegs", playnum);
		makeComponentAvailable("Cyb-Wpn-Atmiss", playnum);
		makeComponentAvailable("CyborgCannon", playnum);
		makeComponentAvailable("CyborgChaingun", playnum);
		makeComponentAvailable("CyborgFlamer01", playnum);
		makeComponentAvailable("Cyb-Wpn-Grenade", playnum);
		makeComponentAvailable("Cyb-Hvywpn-A-T", playnum);
		makeComponentAvailable("Cyb-Hvywpn-Acannon", playnum);
		makeComponentAvailable("Cyb-Hvywpn-HPV", playnum);
		makeComponentAvailable("Cyb-Hvywpn-Mcannon", playnum);
		makeComponentAvailable("Cyb-Hvywpn-PulseLsr", playnum);
		makeComponentAvailable("Cyb-Hvywpn-RailGunner", playnum);
		makeComponentAvailable("Cyb-Hvywpn-TK", playnum);
		makeComponentAvailable("Cyb-Wpn-Laser", playnum);
		makeComponentAvailable("Cyb-Wpn-Rail1", playnum);
		makeComponentAvailable("CyborgRocket", playnum);
		makeComponentAvailable("CyborgRotMG", playnum);
		makeComponentAvailable("Cyb-Wpn-Thermite", playnum);
		makeComponentAvailable("CyborgFlamer01", playnum);
		
		setStructureLimits("A0LightFactory", 5, playnum);	// set structure limits
		setStructureLimits("A0PowerGenerator", 8, playnum);
		setStructureLimits("A0ResearchFacility", 5, playnum);
		setStructureLimits("A0CommandCentre", 1, playnum);
		setStructureLimits("A0ComDroidControl", 1, playnum);
		setStructureLimits("A0CyborgFactory", 5, playnum);
		setStructureLimits("A0VTolFactory1", 5, playnum);
	}
	applyLimitSet();	// set limit options

	const numCleanTech = 4;	// do x for clean	
	const numBaseTech = 18; // do x for base
	var techlist = new Array(
		"R-Vehicle-Prop-Wheels",
		"R-Sys-Spade1Mk1",
		"R-Vehicle-Body01",
		"R-Comp-SynapticLink",
		"R-Wpn-MG1Mk1",
		"R-Defense-HardcreteWall",
		"R-Vehicle-Prop-Wheels",
		"R-Sys-Spade1Mk1",
		"R-Struc-Factory-Cyborg",
		"R-Defense-Pillbox01",
		"R-Defense-Tower01",
		"R-Vehicle-Body01",
		"R-Sys-Engineering01",
		"R-Struc-CommandRelay",
		"R-Vehicle-Prop-Halftracks",
		"R-Comp-CommandTurret01",
		"R-Sys-Sensor-Turret01",
		"R-Wpn-Flamer01Mk1",
		"R-Vehicle-Body05",
		"R-Struc-Research-Module",
		"R-Struc-PowerModuleMk1",
		"R-Struc-Factory-Module",
		"R-Struc-RepairFacility",
		"R-Sys-MobileRepairTurret01",
		"R-Vehicle-Engine01",
		"R-Wpn-MG3Mk1",
		"R-Wpn-Cannon1Mk1",
		"R-Wpn-Mortar01Lt",
		"R-Defense-Pillbox05",
		"R-Defense-TankTrap01",
		"R-Defense-WallTower02",
		"R-Sys-Sensor-Tower01",
		"R-Defense-Pillbox04",
		"R-Wpn-MG2Mk1",
		"R-Wpn-Rocket05-MiniPod",
		"R-Wpn-MG-Damage01",
		"R-Wpn-Rocket-Damage01",
		"R-Defense-WallTower01");

	for (var playnum = 0; playnum < maxPlayers; playnum++)
	{
		enableResearch("R-Sys-Sensor-Turret01", playnum);
		enableResearch("R-Wpn-MG1Mk1", playnum);
		enableResearch("R-Sys-Engineering01", playnum);

		// enable cyborgs components that can't be enabled with research
		makeComponentAvailable("CyborgSpade", playnum);
		makeComponentAvailable("CyborgRepair", playnum);

		if (baseType == CAMP_CLEAN && enumStruct(playnum,"A0Sat-linkCentre").length <= 0)
		{
			setPower(1300, playnum);
			for (var count = 0; count < numCleanTech; count++)
			{
				completeResearch(techlist[count], playnum);
			}
			// Keep only some structures for insane AI
			var structs = enumStruct(playnum);
			for (var i = 0; i < structs.length; i++)
			{
				var s = structs[i];
				if (playerData[playnum].difficulty != INSANE
				    || (s.stattype != WALL && s.stattype != DEFENSE && s.stattype != GATE
				        && s.stattype != RESOURCE_EXTRACTOR))
				{
					removeStruct(s);
				}
			}
		}
		else if (baseType == CAMP_BASE)
		{
			setPower(2500, playnum);
			for (var count = 0; count < numBaseTech; count++)
			{
				completeResearch(techlist[count], playnum);
			}
			// Keep only some structures
			var structs = enumStruct(playnum);
			for (var i = 0; i < structs.length; i++)
			{
				var s = structs[i];
				if ((playerData[playnum].difficulty != INSANE && (s.stattype == WALL || s.stattype == DEFENSE))
				    || s.stattype == GATE || s.stattype == CYBORG_FACTORY || s.stattype == COMMAND_CONTROL)
				{
					removeStruct(s);
				}
			}
		}
		else // CAMP_WALLS
		{
			setPower(2500, playnum);
			for (var count = 0; count < techlist.length; count++)
			{
				completeResearch(techlist[count], playnum);
			}
		}
	}

	// Disabled by default
	setMiniMap(false);
	setDesign(false);
	// This is the only template that should be enabled before design is allowed
	enableTemplate("ConstructionDroid");

	var structlist = enumStruct(me, HQ);
	for (var i = 0; i < structlist.length; i++)
	{
		// Simulate build events to enable minimap/unit design when an HQ exists
		eventStructureBuilt(structlist[i]);
	}

	hackNetOn();
	
	//setTimer("heroChallenge", 10000);
	setTimer("checkEndConditions", 3000);
	setTimer("makeItHappen",3000);
	
}
function makeItHappen()
{
	//var point = 0;
	var temp =  enumDroid(scavengerPlayer);
	if (temp.length<300){
	
		n = 0;
		//var a = enumDroid(scavengerPlayer);
		
		
		for ( i = 0; i<6; i++)
		{
			addScavs(spawnPosition, scavTemplate[5].name, scavTemplate[5].body, scavTemplate[5].propulsion, scavTemplate[5].weapons[0], scavTemplate[5].type,3);
			addScavs(spawnPosition, scavTemplate[0].name, scavTemplate[0].body, scavTemplate[0].propulsion, scavTemplate[0].weapons[0], scavTemplate[0].type,3);
			addScavs(spawnPosition, scavTemplate[1].name, scavTemplate[1].body, scavTemplate[1].propulsion, scavTemplate[1].weapons[0], scavTemplate[1].type,3);
			addScavs(spawnPosition, scavTemplate[2].name, scavTemplate[2].body, scavTemplate[2].propulsion, scavTemplate[2].weapons[0], scavTemplate[2].type,3);
			addScavs(spawnPosition, scavTemplate[3].name, scavTemplate[3].body, scavTemplate[3].propulsion, scavTemplate[3].weapons[0], scavTemplate[3].type,3);
			var a = enumDroid(scavengerPlayer);
			var ammount = a.length ;
			//console(ammount-10);
			
			
			
			//ammount += 10;
			
			
			//console(spawnPosition[n][0],spawnPosition[n][1]);
			n++;
			
			
		}
		for (var j = 0; j<a.length; j++)
			{
				if(j<ammount/6)
				{
					orderDroidLoc(a[j], DORDER_PATROL, attackPosition[0][0],attackPosition[0][1]);
				}else if (j<ammount/3)
				{
					orderDroidLoc(a[j], DORDER_PATROL, attackPosition[1][0],attackPosition[1][1]);
				}
				else if (j<ammount/2)
				{
					orderDroidLoc(a[j], DORDER_PATROL, attackPosition[2][0],attackPosition[2][1]);
				}
				else if(j<ammount/6*4)
				{
					orderDroidLoc(a[j], DORDER_PATROL, attackPosition[3][0],attackPosition[3][1]);
				}
				else if(j<ammount/6*5)
				{
					orderDroidLoc(a[j], DORDER_PATROL, attackPosition[4][0],attackPosition[4][1]);
				}
				else 
				{
					orderDroidLoc(a[j], DORDER_PATROL, attackPosition[5][0],attackPosition[5][1]);
				}
				//console(j + ammount);
			}
	}else{
		removeTimer("makeItHappen");
	}
	
}

function addScavs(Position, name,  body, propulsion, weapons, type,  number)
{	
  
		if (scavengerPlayer > 0)
		{
			for (var i = 0; i<number; i++)
			{
				addDroid(scavengerPlayer, Position[n][0], Position[n][1], name, body, propulsion, "", type, weapons);
			}
	}
	
	
}

/* function heroChallenge(){
	for (var playnum = 0; playnum < maxPlayers; playnum++){
		//console("bla");
		if (playerData[playnum].difficulty == INSANE ){
			var droids = enumDroid(playnum, DROID_ANY);
			for(var j = 0;j<droids.length;j++){
				//console("lalala");
				if (droids[j].experience<2000){
				setDroidExperience(droids[j], 3000.0);
				
				
				}
			}
		}
	}
} */

// /////////////////////////////////////////////////////////////////
// END CONDITIONS
function checkEndConditions()
{
	var factories = enumStruct(me, "A0LightFactory").length + enumStruct(me, "A0CyborgFactory").length;
	var droids = enumDroid(me).length;

	// Losing Conditions
	if (droids == 0 && factories == 0)
	{
		var gameLost = true;

		/* If teams enabled check if all team members have lost  */
		if (alliancesType == ALLIANCES_TEAMS)
		{
			for (var playnum = 0; playnum < maxPlayers; playnum++)
			{
				if (playnum != me && allianceExistsBetween(me, playnum))
				{
					factories = enumStruct(playnum, "A0LightFactory").length + enumStruct(playnum, "A0CyborgFactory").length;
					droids = enumDroid(playnum).length;
					if (droids > 0 || factories > 0)
					{
						gameLost = false;	// someone from our team still alive
						break;
					}
				}
			}
		}

		if (gameLost)
		{
			gameOverMessage(false);
			removeTimer("checkEndConditions");
			return;
		}
	}
	
	// Winning Conditions
	var gamewon = true;

	// check if all enemies defeated
	for (var playnum = 0; playnum < maxPlayers; playnum++)
	{
		if (playnum != me && !allianceExistsBetween(me, playnum))	// checking enemy player
		{
			factories = enumStruct(playnum, "A0LightFactory").length + enumStruct(playnum, "A0CyborgFactory").length; // nope
			droids = enumDroid(playnum).length;
			if (droids > 0 || factories > 0)
			{
				gamewon = false;	//one of the enemies still alive
				break;
			}
		}
	}

	if (gamewon)
	{
		gameOverMessage(true);
		removeTimer("checkEndConditions");
	}
}

// /////////////////////////////////////////////////////////////////
// WARNING MESSAGES
// Base Under Attack
function eventAttacked(victimObj, attackerObj)
{
	if (gameTime > lastHitTime + 10)
	{
		lastHitTime = gameTime;
		if (victimObj.type == STRUCTURE)
		{
			playSound("pcv337.ogg", victimObj.x, victimObj.y, victimObj.z);	// show position if still alive
		}
		else
		{
			playSound("pcv399.ogg", victimObj.x, victimObj.y, victimObj.z);
		}
	}
}

function eventStructureBuilt(struct)
{
	if (struct.player == selectedPlayer && struct.type == STRUCTURE && struct.stattype == HQ)
	{
		setMiniMap(true); // show minimap
		setDesign(true); // permit designs
	}
}

function eventDestroyed(victim)
{
	if (victim.player == selectedPlayer && victim.type == STRUCTURE && victim.stattype == HQ)
	{
		setMiniMap(false); // hide minimap if HQ is destroyed
		setDesign(false); // and disallow design
	}
}
